import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _possibleConstructorReturn from 'babel-runtime/helpers/possibleConstructorReturn';
import _inherits from 'babel-runtime/helpers/inherits';
import invariant from 'invariant';
import { OrderedMap } from 'extendable-immutable';

export var Collection = function (_OrderedMap) {
  _inherits(Collection, _OrderedMap);

  function Collection() {
    _classCallCheck(this, Collection);

    return _possibleConstructorReturn(this, _OrderedMap.apply(this, arguments));
  }

  Collection.of = function of(val) {
    return new Collection(val);
  };

  Collection.isCollection = function isCollection(val) {
    return val && val instanceof Collection;
  };

  // Returns Collection with only incomplete items


  Collection.prototype.filterComplete = function filterComplete() {
    var dependencies = this.dependencies;


    return this.filter(function (x) {
      return dependencies.reduce(function (acc, key) {
        return acc && !(!x.keySeq().includes(key) || x.get(key) !== undefined);
      }, true);
    });
  };

  // Returns Collection with only complete items


  Collection.prototype.filterIncomplete = function filterIncomplete() {
    var dependencies = this.dependencies;


    return this.filter(function (x) {
      return dependencies.reduce(function (acc, key) {
        return acc && (!x.keySeq().includes(key) || x.get(key) !== undefined);
      }, true);
    });
  };

  Collection.prototype.toString = function toString() {
    return this.__toString('Collection {', '}');
  };

  return Collection;
}(OrderedMap);

export default function createCollection(val) {
  return new Collection(val);
}