'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Collection = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

exports.default = createCollection;

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _extendableImmutable = require('extendable-immutable');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Collection = exports.Collection = function (_OrderedMap) {
  (0, _inherits3.default)(Collection, _OrderedMap);

  function Collection() {
    (0, _classCallCheck3.default)(this, Collection);
    return (0, _possibleConstructorReturn3.default)(this, _OrderedMap.apply(this, arguments));
  }

  Collection.of = function of(val) {
    return new Collection(val);
  };

  Collection.isCollection = function isCollection(val) {
    return val && val instanceof Collection;
  };

  // Returns Collection with only incomplete items


  Collection.prototype.filterComplete = function filterComplete() {
    var dependencies = this.dependencies;


    return this.filter(function (x) {
      return dependencies.reduce(function (acc, key) {
        return acc && !(!x.keySeq().includes(key) || x.get(key) !== undefined);
      }, true);
    });
  };

  // Returns Collection with only complete items


  Collection.prototype.filterIncomplete = function filterIncomplete() {
    var dependencies = this.dependencies;


    return this.filter(function (x) {
      return dependencies.reduce(function (acc, key) {
        return acc && (!x.keySeq().includes(key) || x.get(key) !== undefined);
      }, true);
    });
  };

  Collection.prototype.toString = function toString() {
    return this.__toString('Collection {', '}');
  };

  return Collection;
}(_extendableImmutable.OrderedMap);

function createCollection(val) {
  return new Collection(val);
}